<?php
/**
 * Created by PhpStorm.
 * User: root
 * Date: 02/12/2019
 * Time: 11:30
 */
namespace LitCustomerPassword\Bundle\AccountBundle;

use Enlight\Event\SubscriberInterface;
use LitCustomerPassword\Models\User;

class CustomerPassword implements SubscriberInterface
{


    public static function getSubscribedEvents()
    {
        return array(
            'Enlight_Controller_Action_PreDispatch_Frontend_Account' => 'getAccountController'
        );
    }

    /**
     * @return string
     */
    public function getAccountController(\Enlight_Event_EventArgs $args)
    {
        $controller = $args->getSubject();
        $request = $controller->Request();
        $postData = $request->getPost();
        if($request->getActionName() != 'login' || !@$postData['email'] || !@$postData['password']){
            return;
        }
        $user_model = new User();
        $userData = $user_model->getUserByEmail($postData['email']);
        if(!$userData || !$userData['password']){
            return;
        }
        $passwordHash = $userData['password'];
        $all_cart = $user_model->getAllCartType();
        foreach ($all_cart as $cart_file){
            $cart_type = str_replace('.php', '', basename($cart_file));
            Shopware()->Loader()->loadClass($cart_type, $cart_file);
            $cart = new $cart_type();
            try{

                $check = $cart->validatePassword($postData['email'], $postData['password'], $passwordHash);
            }catch (\Exception $e){
                continue;
            }
            if($check){
                $encoder = Shopware()->PasswordEncoder();
                $encode_name = $encoder->getDefaultPasswordEncoderName();
                $new_pass = $encoder->encodePassword($postData['password'], $encode_name);
                Shopware()->Db()->update(
                    's_user',
                    [
                        'password' => $new_pass,
                        'encoder' => $encode_name,
                    ],
                    ['id = ?' => $userData['id']]
                );
                return;
            }
        }
    }

    /**
     * @return string
     */
    public function getPath()
    {
        $plugin = Shopware()->Container()->get('kernel')->getPlugins()['AcmeYourPlugin'];

        return $plugin->getPath();

    }
}